<?php
/**
 * Piwik - Open source web analytics
 * 
 * @link http://piwik.org
 * @license http://www.gnu.org/licenses/gpl-3.0.html GPL v3 or later
 * @version $Id: API.php 2967 2010-08-20 15:12:43Z vipsoft $
 * 
 * @category Piwik_Plugins
 * @package Piwik_Envole
 */

/**
 *
 * @package Piwik_Envole
 */
class Piwik_Envole_API
{
	static private $instance = null;
	static public function getInstance()
	{
		if (self::$instance == null)
		{            
			$c = __CLASS__;
			self::$instance = new $c();
		}
		return self::$instance;
	}
	
	protected function getDataTable($name, $idSite, $period, $date , $segment )
	{
		Piwik::checkUserHasViewAccess( $idSite );
		$archive = Piwik_Archive::build($idSite, $period, $date ,$segment);
		$dataTable = $archive->getDataTable($name);
		$dataTable->filter('Sort',  array(Piwik_Archive::INDEX_NB_VISITS));
		//$dataTable->queueFilter('ColumnCallbackReplace', array('label', 'Piwik_getTimeLabel'));
		$dataTable->queueFilter('ReplaceColumnNames');
		$dataTable->queueFilter('ReplaceSummaryRowLabel');
		return $dataTable;
		
		
	}
	public function getVisitInformationPerProvenance( $idSite, $period, $date, $segment = false )
	{
		return $this->getDataTable('Envole_provenance', $idSite, $period, $date, $segment);
		
	}
	public function getVisitInformationPerRne( $idSite, $period, $date, $segment  = false)
	{
		return $this->getDataTable('Envole_rne', $idSite, $period, $date, $segment);
	}
	public function getVisitInformationPerGroup( $idSite, $period, $date , $segment = false)
	{
		return $this->getDataTable('Envole_group', $idSite, $period, $date, $segment);
	}


}


