<?php
/**
 * Piwik - Open source web analytics
 * 
 * @link http://piwik.org
 * @license http://www.gnu.org/licenses/gpl-3.0.html GPL v3 or later
 * @version $Id: Controller.php 2967 2010-08-20 15:12:43Z vipsoft $
 * 
 * @category Piwik_Plugins
 * @package Piwik_Envole
 */

/**
 *
 * @package Piwik_Envole
 */
class Piwik_Envole_Controller extends Piwik_Controller 
{
	public function index()
	{
		$view = Piwik_View::factory('index');
		$view->dataTableVisitInformationPerRne = $this->getVisitInformationPerRne(true);
		$view->dataTableVisitInformationPerProvenance = $this->getVisitInformationPerProvenance(true);
		
		$view->dataTableVisitInformationPerGroup = $this->getVisitInformationPerGroup(true);
		echo $view->render();
	}
		
	public function getVisitInformationPerProvenance( $fetch = false)
	{		
		/*
		$view = Piwik_ViewDataTable::factory( 'graphVerticalBar');
		$view->init( $this->pluginName,  __FUNCTION__, 'Envole.getEnvoleprovenance' );
		//$view = $this->getStandardDataTableEnvole(__FUNCTION__, 'Envole.getEnvoleprovenance', 'getCitiesFromprovenanceId');
		$view->setColumnTranslation('label', Piwik_Translate('Envoleprovenance_provenance'));
		return $this->renderView($view, $fetch);
		*/
		$view = Piwik_ViewDataTable::factory( 'graphVerticalBar');
		$view->init( $this->pluginName,  __FUNCTION__, "Envole.getVisitInformationPerProvenance" );
		
		//$view->setColumnsToDisplay( array('label','nb_visits') );
		//$view->setSortedColumn( 'label', 'asc' );		
		//$view->setColumnTranslation('label', Piwik_Translate('Envole_ColumnProvenance'));
		//$view->setLimit( 24 );
		//$view->setGraphLimit( 24 );
		//$view->disableSearchBox();
		//$view->disableExcludeLowPopulation();
		//$view->disableOffsetInformationAndPaginationControls();
		//$view->enableShowGoals();
		
		//return $this->renderView($view, $fetch);

		//$view = Piwik_ViewDataTable::factory( $defaultDatatableType);
		//$view->init( $this->pluginName,  $currentControllerAction, $APItoCall );
		$view->disableSearchBox();
		$view->disableExcludeLowPopulation();
		$view->setLimit( 5 );
		$view->setGraphLimit(5);
		
		//$this->setPeriodVariablesView($view);
		//$column = 'nb_visits';
		//if($view->period == 'day')
		//{
		//	$column = 'nb_uniq_visitors';
		//}
		$view->setSortedColumn(  'nb_visits' ,'asc');
		$view->setColumnsToDisplay( array('label', 'nb_visits') );
		return $this->renderView($view, $fetch);
	



		
	}
	
	public function getVisitInformationPerRne( $fetch = false)
	{
		$view = Piwik_ViewDataTable::factory( 'graphVerticalBar');
		$view->init( $this->pluginName,  __FUNCTION__, "Envole.getVisitInformationPerRne" );
		$view->setColumnTranslation('label', Piwik_Translate('Envole_ColumnRne'));
		$view->setColumnsToDisplay( array('label','nb_visits') );
		$view->setSortedColumn( 'label', 'asc' );
		$view->setLimit( 24 );
		$view->setGraphLimit( 24 );
		$view->disableSearchBox();
		$view->disableExcludeLowPopulation();
		$view->disableOffsetInformationAndPaginationControls();
		
		return $this->renderView($view, $fetch);
	}
	public function getVisitInformationPerGroup( $fetch = false)
	{		
		/*
		$view = Piwik_ViewDataTable::factory( 'graphVerticalBar');
		$view->init( $this->pluginName,  __FUNCTION__, 'Envole.getEnvoleprovenance' );
		//$view = $this->getStandardDataTableEnvole(__FUNCTION__, 'Envole.getEnvoleprovenance', 'getCitiesFromprovenanceId');
		$view->setColumnTranslation('label', Piwik_Translate('Envoleprovenance_provenance'));
		return $this->renderView($view, $fetch);
		*/
		$view = Piwik_ViewDataTable::factory( 'graphVerticalBar');
		$view->init( $this->pluginName,  __FUNCTION__, "Envole.getVisitInformationPerGroup" );
		
		//$view->setColumnsToDisplay( array('label','nb_visits') );
		//$view->setSortedColumn( 'label', 'asc' );		
		$view->setColumnTranslation('label', Piwik_Translate('Envole_ColumnGroup'));
		//$view->setLimit( 24 );
		//$view->setGraphLimit( 24 );
		//$view->disableSearchBox();
		//$view->disableExcludeLowPopulation();
		//$view->disableOffsetInformationAndPaginationControls();
		//$view->enableShowGoals();
		
		return $this->renderView($view, $fetch);
	}
}
